package gcspy.interpreter;

import gcspy.comm.BufferedInput;
import gcspy.comm.BufferedOutput;

public class TraceHeaderData {
	/** The number of spaces */
	private int spaceNum;
	/** The events */
	private Events events;
	/** The event filters */
	private EventFilters eventFilters;
	/** General information presented to the client */
	private String generalInfo;

	public TraceHeaderData() {
	}

	public int getSpaceNum() {
		return spaceNum;
	}

	public void setSpaceNum(int spaceNum) {
		this.spaceNum = spaceNum;
	}

	public Events getEvents() {
		return events;
	}

	public void setEvents(Events events) {
		this.events = events;
	}

	public EventFilters getEventFilters() {
		return eventFilters;
	}

	public void setEventFilters(EventFilters eventFilters) {
		this.eventFilters = eventFilters;
	}

	public String getGeneralInfo() {
		return generalInfo;
	}

	public void setGeneralInfo(String generalInfo) {
		this.generalInfo = generalInfo;
	}
	
	/**
	 * Serialise the space number, the general information and the events
	 * 
	 * @param output
	 *            the BufferedOutput on which to serialise
	 */
	public void serialise(BufferedOutput output) {
		output.writeShort((short) getSpaceNum());
		output.writeString(getGeneralInfo());
		getEvents().serialise(output);
	}

	/**
	 * Deserialise the space number, the general information and the events
	 * 
	 * @param input
	 *            the BufferedInput from which to deserialise
	 */
	public static TraceHeaderData deserialise(BufferedInput input) {
		TraceHeaderData result = new TraceHeaderData();
		result.setSpaceNum((int) input.readShort());
		result.setGeneralInfo(input.readString());
		result.setEvents(Events.deserialise(input));
		return result;
	}	
}